

import java.io.PrintStream;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;

public class CameraMIDlet extends MIDlet
    implements CommandListener
{

    public CameraMIDlet()
    {
        playerType = "capture://image";
        exitcmd = new Command("Exit", 7, 0);
        backcmd = new Command("Back", 7, 0);
        selcmd = new Command("Select", 1, 0);
        openMenu = new List("AMMS :: Main Menu", 3);
        phoneChoice = new List("Start Menu: ", 3);
        initGUI();
        System.out.println(System.getProperty("microedition.platform"));
    }

    public void initGUI()
    {
        display = Display.getDisplay(this);
        phoneChoice.append("Camera Controls", null);
     
        phoneChoice.setSelectCommand(selcmd);
        phoneChoice.addCommand(exitcmd);
        phoneChoice.setCommandListener(this);
        openMenu.deleteAll();
        openMenu.append("Supported Features", null);
        openMenu.append("Camera Control", null);
        openMenu.append("Exposure Control", null);
        openMenu.append("Flash Control", null);
        openMenu.append("Focus Control", null);
        openMenu.append("Snapshot Control", null);
        openMenu.append("Zoom Control", null);
        openMenu.addCommand(backcmd);
        openMenu.setSelectCommand(selcmd);
        openMenu.setCommandListener(this);
        suppFeat = 0;
        cameracontrol = 1;
        exposurecontrol = 2;
        flashcontrol = 3;
        focuscontrol = 4;
        snapshotcontrol = 5;
        zoomcontrol = 6;
        allcontrols = 7;
    }

    protected void destroyApp(boolean flag)
        throws MIDletStateChangeException
    {
    }

    protected void pauseApp()
    {
    }

    protected void startApp()
        throws MIDletStateChangeException
    {
      
            display.setCurrent(phoneChoice);
      
    }

    public static Display getDisplay()
    {
        return display;
    }

    public void showAlert(String title, String message, Displayable nextDisp)
    {
        alert = new Alert(title);
        alert.setString(message);
        alert.setTimeout(-2);
        if(nextDisp != null)
        {
            getDisplay().setCurrent(alert, nextDisp);
        } else
        {
            getDisplay().setCurrent(alert);
            alert.setCommandListener(this);
        }
    }

    public boolean checkCameraSupport()
    {
        String propValue = System.getProperty("supports.video.capture");
        return propValue != null && propValue.equals("true");
    }

    public String GetPlayerType()
    {
        return playerType;
    }

    public void commandAction(Command c, Displayable d)
    {
        if(c == exitcmd)
            notifyDestroyed();
        else
        if(c == backcmd)
            display.setCurrent(phoneChoice);
        else
        if(c == selcmd && d == phoneChoice)
        {
            if(phoneChoice.getSelectedIndex() == 0)
                playerType = "capture://video";
            display.setCurrent(openMenu);
        } else
        if(c == selcmd && d == openMenu)
        {
            int index = openMenu.getSelectedIndex();
            if(index == suppFeat)
                display.setCurrent(new SupportedFormats(this));
            else
            if(index == cameracontrol)
            {
                TestCameraControl testcc = new TestCameraControl(this);
                if(testcc.isSupported())
                    getDisplay().setCurrent(((TestControl) (testcc)).canvas);
                else
                    showAlert("Camera Control not supported", "Camera Control is not supported on this phone.", openMenu);
            } else
            if(index == flashcontrol)
            {
                TestFlashControl testfc = new TestFlashControl(this);
                if(testfc.isSupported())
                    getDisplay().setCurrent(((TestControl) (testfc)).canvas);
                else
                    showAlert("Flash Control not supported", "Flash Control is not supported on this phone.", openMenu);
            } else
            if(index == focuscontrol)
            {
                TestFocusControl testfocus = new TestFocusControl(this);
                if(testfocus.isSupported())
                    getDisplay().setCurrent(((TestControl) (testfocus)).canvas);
                else
                    showAlert("Control not supported", "Zoom Control is not supported on this phone.", openMenu);
            } else
            if(index == zoomcontrol)
            {
                TestZoomControl testzoom = new TestZoomControl(this);
                if(testzoom.isSupported())
                    getDisplay().setCurrent(((TestControl) (testzoom)).canvas);
                else
                    showAlert("Control not supported", "Zoom Control is not supported on this phone.", openMenu);
            } else
            if(index == snapshotcontrol)
            {
                TestSnapshotControl tsc = new TestSnapshotControl(this);
                if(tsc.isSupported())
                    getDisplay().setCurrent(((TestControl) (tsc)).canvas);
                else
                    showAlert("Control not supported", "Snapshot Control is not supported on this phone.", openMenu);
            } else
            if(index == exposurecontrol)
            {
                TestExposureControl ec = new TestExposureControl(this);
                if(ec.isSupported())
                    getDisplay().setCurrent(((TestControl) (ec)).canvas);
                else
                    showAlert("Control not supported", "Exposure Control is not supported on this phone.", openMenu);
            }
        }
    }

    private static Display display = null;
    Alert alert;
    List phoneChoice;
    List openMenu;
    Command exitcmd;
    Command selcmd;
    Command backcmd;
    int suppFeat;
    int cameracontrol;
    int flashcontrol;
    int focuscontrol;
    int snapshotcontrol;
    int zoomcontrol;
    int exposurecontrol;
    int allcontrols;
    String playerType;

}
